%define DATE 20040420
%define gcc_version 3.4.0
%define gcc_release 1
%define _unpackaged_files_terminate_build 0
%define multilib_64_archs sparc64 ppc64 s390x x86_64
%define build_ada 0
%define build_java 1
%ifarch s390x
%define multilib_32_arch s390
%endif
%ifarch sparc64
%define multilib_32_arch sparc
%endif
%ifarch ppc64
%define multilib_32_arch ppc
%endif
%ifarch x86_64
%define multilib_32_arch i386
%endif
Summary: Prerelease of GCC version 3.4
Name: gcc34
Version: %{gcc_version}
Release: %{gcc_release}
Copyright: GPL
Group: Development/Languages
Source0: gcc-%{version}-%{DATE}.tar.bz2
Source1: libgcc_post_upgrade.c
URL: http://gcc.gnu.org
BuildRoot: /var/tmp/gcc-root
# Need binutils with -pie support
# Need --as-needed/--no-as-needed support
Requires: binutils >= 2.15.90.0.1.1-2
BuildRequires: zlib-devel, gettext, dejagnu, bison, flex, texinfo
# Make sure pthread.h doesn't contain __thread tokens
BuildRequires: glibc-devel >= 2.2.90-12
%if %{build_ada}
# Ada requires Ada to build
BuildRequires: gcc-gnat >= 3.1, libgnat >= 3.1
%endif
# Need .eh_frame ld optimizations
# Need proper visibility support
# Need -pie support
Requires: binutils >= 2.14.90.0.4-4
# Make sure gdb will understand DW_FORM_strp
Conflicts: gdb < 5.1-2
Requires: glibc-devel >= 2.2.90-12
Requires: libgcc >= 3.3.2-7
Prereq: /sbin/install-info
AutoReq: true

Patch1: gcc34-multi32-hack.patch
Patch2: gcc34-ice-hack.patch
Patch3: gcc34-ppc64-m32-m64-multilib-only.patch
Patch4: gcc34-2.96-RH-compat.patch
Patch5: gcc34-fde-merge-compat.patch
Patch6: gcc34-c++filt.patch
Patch7: gcc34-ada.patch
Patch8: gcc34-s390-ldso.patch
Patch9: gcc34-debug-pr7241.patch
Patch10: gcc34-mcpu-undeprecate.patch
Patch11: gcc34-crtbegin-jcr.patch
Patch12: gcc34-genoutput-trailpad.patch
Patch13: gcc34-p4-prologue-move.patch
Patch14: gcc34-i386-branch-mispredict.patch
Patch15: gcc34-warn-alloca-vla.patch
Patch16: gcc34-min-pretend-dynamic-size.patch
Patch17: gcc34-i386-fistp.patch
Patch18: gcc34-ppc-tls-dwarf2.patch
Patch19: gcc34-java-pr14581.patch
Patch20: gcc34-nocona.patch
Patch21: gcc34-x86_64-no3dnowprefetch.patch
Patch22: gcc34-cselib-unused.patch
Patch23: gcc34-x86_64-tests.patch
Patch24: gcc34-pr13488.patch

%define _gnu %{nil}
%ifarch sparc
%define gcc_target_platform sparc64-%{_vendor}-%{_target_os}
%endif
%ifarch ppc
%define gcc_target_platform ppc64-%{_vendor}-%{_target_os}
%endif
%ifnarch sparc ppc
%define gcc_target_platform %{_target_platform}
%endif

%description
The gcc package contains the GNU Compiler Collection version 3.4.

%package c++
Summary: C++ support for GCC version 3.4
Group: Development/Languages
Requires: gcc34 = %{version}-%{release}
Requires: libstdc++34 = %{version}
Requires: libstdc++34-devel = %{version}
Autoreq: true

%description c++
This package adds C++ support to the GNU Compiler Collection.
It includes support for most of the current C++ specification,
including templates and exception handling.

%package -n libstdc++34
Summary: GNU Standard C++ Library version 3.4
Group: System Environment/Libraries
Autoreq: true

%description -n libstdc++34
The libstdc++ package contains a rewritten standard compliant GCC Standard
C++ Library version 3.4

%package -n libstdc++34-devel
Summary: Header files and libraries for C++ development
Group: Development/Libraries
Requires: libstdc++34 = %{version}-%{release}
Autoreq: true

%description -n libstdc++34-devel
This is the GNU implementation of the standard C++ libraries.  This
package includes the header files and libraries needed for C++
development. This includes rewritten implementation of STL.

%package java
Summary: Java support for GCC
Group: Development/Languages
Requires: gcc34 = %{version}-%{release}
Requires: libgcj34 >= %{version}, libgcj34-devel >= %{version}, zlib-devel
Prereq: /sbin/install-info
Autoreq: true

%description java
This package adds support for compiling Java(tm) programs and
bytecode into native code.

%package -n libgcj34
Summary: Java runtime library for GCC version 3.4
Group: System Environment/Libraries
Prereq: /sbin/install-info
Requires: zip >= 2.1
Autoreq: true

%description -n libgcj34
The Java(tm) runtime library. You will need this package to run your Java
programs compiled using the Java compiler from GNU Compiler Collection (gcj).

%package -n libgcj34-devel
Summary: Libraries for Java development using GCC
Group: Development/Languages
Requires: zip >= 2.1, libgcj34 = %{version}
Autoreq: true

%description -n libgcj34-devel
The Java(tm) static libraries and C header files. You will need this
package to compile your Java programs using the GCC Java compiler (gcj).

%prep
%setup -q -n gcc-%{version}-%{DATE}
%patch2 -p0 -b .ice-hack~
%patch3 -p0 -b .ppc64-m32-m64-multilib-only~
%patch4 -p0 -b .2.96-RH-compat~
%patch5 -p0 -b .fde-merge-compat~
%patch6 -p0 -b .c++filt~
%patch7 -p0 -b .ada~
%patch8 -p0 -b .s390-ldso~
%patch9 -p0 -b .debug-pr7241~
%patch10 -p0 -b .mcpu-undeprecate~
%patch11 -p0 -b .crtbegin-jcr~
%patch12 -p0 -b .genoutput-trailpad~
%patch13 -p0 -b .p4-prologue-move~
%patch14 -p0 -b .i386-branch-mispredict~
%patch15 -p0 -b .warn-alloca-vla~
%patch16 -p0 -b .min-pretend-dynamic-size~
%patch17 -p0 -b .i386-fistp~
%patch18 -p0 -b .ppc-tls-dwarf2~
%patch19 -p0 -b .java-pr14581~
%patch20 -p0 -b .nocona~
%patch21 -p0 -b .x86_64-no3dnowprefetch~
%patch22 -p0 -b .cselib-unused~
%patch23 -p0 -b .x86_64-tests~
%patch24 -p0 -b .pr13488~

perl -pi -e 's/3\.4\.0/3.4.0/' gcc/version.c
perl -pi -e 's/"%{gcc_version}"/"%{gcc_version} \(release\)"/' gcc/version.c
perl -pi -e 's/\((prerelease|experimental|release|Red Hat[^)]*)\)/\(Red Hat Linux %{version}-%{gcc_release}\)/' gcc/version.c

# Misdesign in libstdc++
cp -a libstdc++-v3/config/cpu/i{4,3}86/atomicity.h

./contrib/gcc_update --touch

%build

rm -fr obj-%{gcc_target_platform}
mkdir obj-%{gcc_target_platform}
cd obj-%{gcc_target_platform}

if [ ! -f /usr/lib/locale/de_DE/LC_CTYPE ]; then
  mkdir locale
  localedef -f ISO-8859-1 -i de_DE locale/de_DE
  export LOCPATH=`pwd`/locale:/usr/lib/locale
fi

CC=gcc
OPT_FLAGS=`echo $RPM_OPT_FLAGS|sed -e 's/-fno-rtti//g' -e 's/-fno-exceptions//g'`
%ifarch sparc sparc64
OPT_FLAGS=`echo $OPT_FLAGS|sed -e 's/-m64//g' -e 's/-m32//g' -e 's/-mcpu=ultrasparc/-mtune=ultrasparc/g'`
%endif
%ifarch ppc ppc64
OPT_FLAGS=`echo $OPT_FLAGS|sed -e 's/-m64//g' -e 's/-m32//g'`
%endif
%ifarch sparc64
cat > gcc64 <<"EOF"
#!/bin/sh
exec /usr/bin/gcc -m64 "$@"
EOF
chmod +x gcc64
CC=`pwd`/gcc64
%endif
%ifarch ppc64
if gcc -m64 -xc -S /dev/null -o - > /dev/null 2>&1; then
  cat > gcc64 <<"EOF"
#!/bin/sh
exec /usr/bin/gcc -m64 "$@"
EOF
  chmod +x gcc64
  CC=`pwd`/gcc64
fi
%endif
CC="$CC" CFLAGS="$OPT_FLAGS" CXXFLAGS="$OPT_FLAGS" XCFLAGS="$OPT_FLAGS" TCFLAGS="$OPT_FLAGS" \
	GCJFLAGS="$OPT_FLAGS" \
	../configure --prefix=%{_prefix} --mandir=%{_mandir} --infodir=%{_infodir} \
	--enable-shared --enable-threads=posix --disable-checking \
	--with-system-zlib --enable-__cxa_atexit --disable-libunwind-exceptions \
%if !%{build_ada}
	--enable-languages=c,c++,objc,java,f77 \
%endif
%if !%{build_java}
	--disable-libgcj \
%endif
%ifarch sparc
	--host=%{gcc_target_platform} --build=%{gcc_target_platform} --target=%{gcc_target_platform} --with-cpu=v7
%endif
%ifarch ppc
	--host=%{gcc_target_platform} --build=%{gcc_target_platform} --target=%{gcc_target_platform} --with-cpu=default32
%endif
%ifnarch sparc ppc
	--host=%{gcc_target_platform}
%endif

#make %{?_smp_mflags} BOOT_CFLAGS="$OPT_FLAGS" bootstrap
%ifarch %{ix86} x86_64
make %{?_smp_mflags} BOOT_CFLAGS="$OPT_FLAGS" profiledbootstrap
%else
make %{?_smp_mflags} BOOT_CFLAGS="$OPT_FLAGS" bootstrap-lean
%endif

%if %{build_ada}
# This doesn't work with -jN
make -C gcc BOOT_CFLAGS="$OPT_FLAGS" gnatlib-shared
make -C gcc BOOT_CFLAGS="$OPT_FLAGS" gnattools
ln -sf libgnat.so.1 gcc/ada/rts/libgnat-3.4.so
ln -sf libgnarl.so.1 gcc/ada/rts/libgnarl-3.4.so
%endif

# run the tests.
make %{?_smp_mflags} -k check || :
make -C %{gcc_target_platform}/libstdc++-v3/testsuite -k check-abi-verbose || :
echo ====================TESTING=========================
( ../contrib/test_summary || : ) 2>&1 | sed -n '/^cat.*EOF/,/^EOF/{/^cat.*EOF/d;/^EOF/d;/^LAST_UPDATED:/d;p;}'
make -C %{gcc_target_platform}/libstdc++-v3/testsuite -k check-abi || :
echo ====================TESTING END=====================
#cd %{gcc_target_platform}/libstdc++-v3
#./mkcheck 0
#cd ../..

# Make protoize
make -C gcc CC="./xgcc -B ./ -O2" proto

# Make c++filt
make -C %{gcc_target_platform}/libiberty CFLAGS="$RPM_OPT_FLAGS" c++filt

# Make generated man pages even if Pod::Man is not new enough
perl -pi -e 's/head3/head2/' ../contrib/texi2pod.pl
for i in ../gcc/doc/*.texi; do
  cp -a $i $i.orig; sed 's/ftable/table/' $i.orig > $i
done
make -C gcc generated-manpages
for i in ../gcc/doc/*.texi; do mv -f $i.orig $i; done

# Copy various doc files here and there
cd ..
mkdir -p rpm.doc/g77 rpm.doc/objc
mkdir -p rpm.doc/boehm-gc rpm.doc/fastjar rpm.doc/libffi rpm.doc/libjava

(cd gcc/f; for i in ChangeLog*; do
	cp -p $i ../../rpm.doc/g77/$i.f
done)
(cd libf2c; for i in ChangeLog*; do
	cp -p $i ../rpm.doc/g77/$i.libf2c
done)
(cd gcc/objc; for i in README*; do
	cp -p $i ../../rpm.doc/objc/$i.objc
done)
(cd libobjc; for i in README*; do
	cp -p $i ../rpm.doc/objc/$i.libobjc
done)
(cd boehm-gc; for i in ChangeLog*; do
	cp -p $i ../rpm.doc/boehm-gc/$i.gc
done)
(cd fastjar; for i in ChangeLog* README*; do
	cp -p $i ../rpm.doc/fastjar/$i.fastjar
done)
(cd libffi; for i in ChangeLog* README* LICENSE; do
	cp -p $i ../rpm.doc/libffi/$i.libffi
done)
(cd libjava; for i in ChangeLog* README*; do
	cp -p $i ../rpm.doc/libjava/$i.libjava
done)

%install
rm -fr $RPM_BUILD_ROOT

perl -pi -e \
  's~href="l(ibstdc|atest)~href="http://gcc.gnu.org/onlinedocs/libstdc++/l\1~' \
  libstdc++-v3/docs/html/documentation.html
ln -sf documentation.html libstdc++-v3/docs/html/index.html
find libstdc++-v3/docs/html -name CVS | xargs rm -rf

cd obj-%{gcc_target_platform}

if [ ! -f /usr/lib/locale/de_DE/LC_CTYPE ]; then
  export LOCPATH=`pwd`/locale:/usr/lib/locale
fi

TARGET_PLATFORM=%{gcc_target_platform}

# There are some MP bugs in libstdc++ and libjava Makefiles
make -C %{gcc_target_platform}/libstdc++-v3
%if %{build_java}
make -C %{gcc_target_platform}/libjava
%endif

make prefix=$RPM_BUILD_ROOT%{_prefix} mandir=$RPM_BUILD_ROOT%{_mandir} \
  infodir=$RPM_BUILD_ROOT%{_infodir} install
%if %{build_ada}
for i in $RPM_BUILD_ROOT%{_infodir}/gnat_ug_unx.info*; do
  sed 's/gnat_ug_unx/gnat_ug/g' $i > `echo $i | sed 's|/gnat_ug_unx\.info|/gnat_ug.info|'`
done
rm -f $RPM_BUILD_ROOT%{_infodir}/gnat_ug_{vms,wnt,vxw}.info*
chmod 644 $RPM_BUILD_ROOT%{_infodir}/gnat*
%endif

FULLPATH=$RPM_BUILD_ROOT%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}
FULLEPATH=$RPM_BUILD_ROOT%{_prefix}/libexec/gcc/%{gcc_target_platform}/%{gcc_version}

cp -a %{gcc_target_platform}/libiberty/c++filt $RPM_BUILD_ROOT%{_prefix}/bin/c++filt
chmod 755 $RPM_BUILD_ROOT%{_prefix}/bin/c++filt

# fix some things
ln -sf gcc $RPM_BUILD_ROOT%{_prefix}/bin/cc
mkdir -p $RPM_BUILD_ROOT/lib
ln -sf ..%{_prefix}/bin/cpp $RPM_BUILD_ROOT/lib/cpp
ln -sf g77 $RPM_BUILD_ROOT%{_prefix}/bin/f77
rm -f $RPM_BUILD_ROOT%{_infodir}/dir
gzip -9 $RPM_BUILD_ROOT%{_infodir}/*.info*
ln -sf gcc $RPM_BUILD_ROOT%{_prefix}/bin/gnatgcc

%ifarch sparc ppc
ln -f $RPM_BUILD_ROOT%{_prefix}/bin/%{gcc_target_platform}-gcc \
  $RPM_BUILD_ROOT%{_prefix}/bin/%{_target_platform}-gcc
%endif
%ifarch sparc
ln -sf %{gcc_target_platform} \
  $RPM_BUILD_ROOT%{_prefix}/include/c++/%{gcc_version}/%{_target_platform}
%endif
%ifarch ppc
mv $RPM_BUILD_ROOT%{_prefix}/include/c++/%{gcc_version}/%{gcc_target_platform} \
  $RPM_BUILD_ROOT%{_prefix}/include/c++/%{gcc_version}/%{_target_platform}
ln -sf %{_target_platform} \
  $RPM_BUILD_ROOT%{_prefix}/include/c++/%{gcc_version}/%{gcc_target_platform}
%endif
%ifarch sparc64
ln -f $RPM_BUILD_ROOT%{_prefix}/bin/%{gcc_target_platform}-gcc \
  $RPM_BUILD_ROOT%{_prefix}/bin/sparc-%{_vendor}-%{_target_os}-gcc
%endif
%ifarch ppc64
ln -f $RPM_BUILD_ROOT%{_prefix}/bin/%{gcc_target_platform}-gcc \
  $RPM_BUILD_ROOT%{_prefix}/bin/ppc-%{_vendor}-%{_target_os}-gcc
%endif

%ifarch sparc ppc
FULLLPATH=$FULLPATH/lib32
%endif
%ifarch sparc64 ppc64
FULLLPATH=$FULLPATH/lib64
%endif
if [ -n "$FULLLPATH" ]; then
  mkdir -p $FULLLPATH
else
  FULLLPATH=$FULLPATH
fi

if [ "%{build_java}" -gt 0 ]; then
mv $RPM_BUILD_ROOT%{_prefix}/%{_lib}/libgcj.*a $FULLLPATH/
mv $RPM_BUILD_ROOT%{_prefix}/%{_lib}/lib-org-*.*a $FULLLPATH/
mv $RPM_BUILD_ROOT%{_prefix}/lib/libgcj.spec $FULLPATH/
#mv $RPM_BUILD_ROOT%{_prefix}/include/gc*.h $FULLPATH/include/
mv $RPM_BUILD_ROOT%{_prefix}/include/j*.h $FULLPATH/include/
#mv -f $RPM_BUILD_ROOT%{_prefix}/include/{java,javax,gnu,org} $FULLPATH/include/
mv -f $RPM_BUILD_ROOT%{_prefix}/include/{java,javax,gnu} $FULLPATH/include/
mkdir -p $FULLPATH/include/gcj
mv -f $RPM_BUILD_ROOT%{_prefix}/include/gcj/* $FULLPATH/include/gcj/
rmdir $RPM_BUILD_ROOT%{_prefix}/include/gcj
fi

mkdir -p $RPM_BUILD_ROOT/%{_lib}
mv -f $RPM_BUILD_ROOT%{_prefix}/%{_lib}/libgcc_s.so.1 $RPM_BUILD_ROOT/%{_lib}/libgcc_s-%{gcc_version}-%{DATE}.so.1
chmod 755 $RPM_BUILD_ROOT/%{_lib}/libgcc_s-%{gcc_version}-%{DATE}.so.1
ln -sf libgcc_s-%{gcc_version}-%{DATE}.so.1 $RPM_BUILD_ROOT/%{_lib}/libgcc_s.so.1
ln -sf /%{_lib}/libgcc_s.so.1 $FULLPATH/libgcc_s.so
%ifarch sparc ppc
ln -sf /lib64/libgcc_s.so.1 $FULLPATH/libgcc_s_64.so
%endif
%ifarch %{multilib_64_archs}
ln -sf /lib/libgcc_s.so.1 $FULLPATH/libgcc_s_32.so
%endif

%if %{build_ada}
mv -f $FULLPATH/adalib/libgnarl-*.so.* $RPM_BUILD_ROOT%{_prefix}/%{_lib}/
mv -f $FULLPATH/adalib/libgnat-*.so.* $RPM_BUILD_ROOT%{_prefix}/%{_lib}/
rm -f $FULLPATH/adalib/libgnarl.so* $FULLPATH/adalib/libgnat.so*
%endif

pushd $FULLPATH
if [ "%{_lib}" = "lib" ]; then
ln -sf ../../../libobjc.so.1 libobjc.so
ln -sf ../../../libstdc++.so.6.* libstdc++.so
%if %{build_java}
ln -sf ../../../libgcj.so.5.* libgcj.so
ln -sf ../../../lib-org-w3c-dom.so.5.* lib-org-w3c-dom.so
ln -sf ../../../lib-org-xml-sax.so.5.* lib-org-xml-sax.so
%endif
ln -sf ../../../libg2c.so.0.* libg2c.so
%if %{build_ada}
cd adalib
ln -sf ../../../../libgnarl-*.so.* libgnarl.so
ln -sf ../../../../libgnat-*.so.* libgnat.so
cd ..
%endif
else
ln -sf ../../../../%{_lib}/libobjc.so.1 libobjc.so
ln -sf ../../../../%{_lib}/libstdc++.so.6.* libstdc++.so
%if %{build_java}
ln -sf ../../../../%{_lib}/libgcj.so.5.* libgcj.so
ln -sf ../../../../%{_lib}/lib-org-w3c-dom.so.5.* lib-org-w3c-dom.so
ln -sf ../../../../%{_lib}/lib-org-xml-sax.so.5.* lib-org-xml-sax.so
%endif
ln -sf ../../../../%{_lib}/libg2c.so.0.* libg2c.so
%if %{build_ada}
cd adalib
ln -sf ../../../../../%{_lib}/libgnarl-*.so.* libgnarl.so
ln -sf ../../../../../%{_lib}/libgnat-*.so.* libgnat.so
cd ..
%endif
fi
mv -f $RPM_BUILD_ROOT%{_prefix}/%{_lib}/libstdc++.*a $FULLLPATH/
mv -f $RPM_BUILD_ROOT%{_prefix}/%{_lib}/libsupc++.*a .
mv -f $RPM_BUILD_ROOT%{_prefix}/%{_lib}/libg2c.*a .
mv -f $RPM_BUILD_ROOT%{_prefix}/%{_lib}/libfrtbegin.*a .
mv -f $RPM_BUILD_ROOT%{_prefix}/%{_lib}/libobjc.*a .

%ifarch sparc ppc
ln -sf ../../../../../lib64/libobjc.so.1 64/libobjc.so
ln -sf ../`echo ../../../../lib/libstdc++.so.6.* | sed s~/lib/~/lib64/~` 64/libstdc++.so
if [ "%{build_java}" -gt 0 ]; then
ln -sf ../`echo ../../../../lib/libgcj.so.5.* | sed s~/lib/~/lib64/~` 64/libgcj.so
ln -sf ../`echo ../../../../lib/lib-org-w3c-dom.so.5.* | sed s~/lib/~/lib64/~` 64/lib-org-w3c-dom.so
ln -sf ../`echo ../../../../lib/lib-org-xml-sax.so.5.* | sed s~/lib/~/lib64/~` 64/lib-org-xml-sax.so
fi
ln -sf ../`echo ../../../../lib/libg2c.so.0.* | sed s~/lib/~/lib64/~` 64/libg2c.so
mv -f $RPM_BUILD_ROOT%{_prefix}/lib64/libsupc++.*a 64/
mv -f $RPM_BUILD_ROOT%{_prefix}/lib64/libg2c.*a 64/
mv -f $RPM_BUILD_ROOT%{_prefix}/lib64/libfrtbegin.*a 64/
mv -f $RPM_BUILD_ROOT%{_prefix}/lib64/libobjc.*a 64/
ln -sf lib32/libstdc++.a libstdc++.a
ln -sf ../lib64/libstdc++.a 64/libstdc++.a
if [ "%{build_java}" -gt 0 ]; then
ln -sf lib32/libgcj.a libgcj.a
ln -sf ../lib64/libgcj.a 64/libgcj.a
ln -sf lib32/lib-org-w3c-dom.a lib-org-w3c-dom.a
ln -sf ../lib64/lib-org-w3c-dom.a 64/lib-org-w3c-dom.a
ln -sf lib32/lib-org-xml-sax.a lib-org-xml-sax.a
ln -sf ../lib64/lib-org-xml-sax.a 64/lib-org-xml-sax.a
fi
%endif
%ifarch %{multilib_64_archs}
mkdir -p 32
ln -sf ../../../../libobjc.so.1 32/libobjc.so
ln -sf ../`echo ../../../../lib64/libstdc++.so.6.* | sed s~/../lib64/~/~` 32/libstdc++.so
if [ "%{build_java}" -gt 0 ]; then
ln -sf ../`echo ../../../../lib64/libgcj.so.5.* | sed s~/../lib64/~/~` 32/libgcj.so
ln -sf ../`echo ../../../../lib64/lib-org-w3c-dom.so.5.* | sed s~/../lib64/~/~` 32/lib-org-w3c-dom.so
ln -sf ../`echo ../../../../lib64/lib-org-xml-sax.so.5.* | sed s~/../lib64/~/~` 32/lib-org-xml-sax.so
fi
ln -sf ../`echo ../../../../lib64/libg2c.so.0.* | sed s~/../lib64/~/~` 32/libg2c.so
mv -f $RPM_BUILD_ROOT%{_prefix}/lib/libsupc++.*a 32/
mv -f $RPM_BUILD_ROOT%{_prefix}/lib/libg2c.*a 32/
mv -f $RPM_BUILD_ROOT%{_prefix}/lib/libfrtbegin.*a 32/
mv -f $RPM_BUILD_ROOT%{_prefix}/lib/libobjc.*a 32/
%endif
%ifarch sparc64 ppc64
ln -sf ../lib32/libstdc++.a 32/libstdc++.a
ln -sf lib64/libstdc++.a libstdc++.a
if [ "%{build_java}" -gt 0 ]; then
ln -sf ../lib32/libgcj.a 32/libgcj.a
ln -sf lib64/libgcj.a libgcj.a
ln -sf ../lib32/lib-org-w3c-dom.a 32/lib-org-w3c-dom.a
ln -sf lib64/lib-org-w3c-dom.a lib-org-w3c-dom.a
ln -sf ../lib32/lib-org-xml-sax.a 32/lib-org-xml-sax.a
ln -sf lib64/lib-org-xml-sax.a lib-org-xml-sax.a
fi
%else
%ifarch %{multilib_64_archs}
ln -sf ../../../%{multilib_32_arch}-%{_vendor}-%{_target_os}/%{gcc_version}/libstdc++.a 32/libstdc++.a
if [ "%{build_java}" -gt 0 ]; then
ln -sf ../../../%{multilib_32_arch}-%{_vendor}-%{_target_os}/%{gcc_version}/libgcj.a 32/libgcj.a
ln -sf ../../../%{multilib_32_arch}-%{_vendor}-%{_target_os}/%{gcc_version}/lib-org-w3c-dom.a 32/lib-org-w3c-dom.a
ln -sf ../../../%{multilib_32_arch}-%{_vendor}-%{_target_os}/%{gcc_version}/lib-org-xml-sax.a 32/lib-org-xml-sax.a
fi
%endif
%endif

# Strip debug info from Fortran/ObjC/Java static libraries
strip -g `find . \( -name libg2c.a -o -name libobjc.a -o -name libgcj.a \
		    -o -name lib-org-w3c-dom.a -o -name lib-org-xml-sax.a \
		    -o -name libgcc.a -o -name libgcov.a \) -a -type f`
popd
chmod 755 $RPM_BUILD_ROOT%{_prefix}/%{_lib}/libg2c.so.0.*
chmod 755 $RPM_BUILD_ROOT%{_prefix}/%{_lib}/libobjc.so.1.*

%if %{build_ada}
chmod 755 $RPM_BUILD_ROOT%{_prefix}/%{_lib}/libgnarl*so*
chmod 755 $RPM_BUILD_ROOT%{_prefix}/%{_lib}/libgnat*so*
%endif

for h in `find $FULLPATH/include -name \*.h`; do
  if grep -q 'It has been auto-edited by fixincludes from' $h; then
    rh=`grep -A2 'It has been auto-edited by fixincludes from' $h | tail -1 | sed 's|^.*"\(.*\)".*$|\1|'`
    diff -up $rh $h || :
    rm -f $h
  fi
done

cat > $RPM_BUILD_ROOT%{_prefix}/bin/c89 <<"EOF"
#!/bin/sh
fl="-std=c89"
for opt; do
  case "$opt" in
    -ansi|-std=c89|-std=iso9899:1990) fl="";;
    -std=*) echo "`basename $0` called with non ANSI/ISO C option $opt" >&2
	    exit 1;;
  esac
done
exec %{_prefix}/bin/gcc $fl ${1+"$@"}
EOF
cat > $RPM_BUILD_ROOT%{_prefix}/bin/c99 <<"EOF"
#!/bin/sh
fl="-std=c99"
for opt; do
  case "$opt" in
    -std=c99|-std=iso9899:1999) fl="";;
    -std=*) echo "`basename $0` called with non ISO C99 option $opt" >&2
	    exit 1;;
  esac
done
exec %{_prefix}/bin/gcc $fl ${1+"$@"}
EOF
chmod 755 $RPM_BUILD_ROOT%{_prefix}/bin/c?9

mkdir -p $RPM_BUILD_ROOT%{_prefix}/sbin
gcc -static -Os %{SOURCE1} -o $RPM_BUILD_ROOT%{_prefix}/sbin/libgcc_post_upgrade
strip $RPM_BUILD_ROOT%{_prefix}/sbin/libgcc_post_upgrade

cd ..

for i in $RPM_BUILD_ROOT%{_prefix}/bin/{*gcc,*++,gcov}; do
  mv -f $i ${i}34
done
%if %{build_java}
for i in $RPM_BUILD_ROOT%{_prefix}/bin/{gcj,gcjh,jcf-dump,jv*,gij,*jar,rmi*}; do
  mv -f $i ${i}34
done
%endif

# Remove binaries we will not be including, so that they don't end up in
# gcc34-debuginfo
rm -f $RPM_BUILD_ROOT%{_prefix}/bin/{c++34,c++filt,c89,c99,cpp,g77,gccbug,*-linux-gcc-3*,*-linux-gcj,*-linux-gcjh,protoize,unprotoize}
rm -f $RPM_BUILD_ROOT%{_lib}/libgcc_s-3*
rm -f $FULLPATH/{,32/,64/}{libfrtbegin.a,libg2c.a,libobjc.a}
rm -f $RPM_BUILD_ROOT%{_prefix}/%{_lib}/{libffi*,libg2c*,libiberty.a,libobjc*}
rm -f $FULLEPATH/{cc1obj,f771,install-tools/{mkheaders,fixincl}}
rm -f $RPM_BUILD_ROOT%{_prefix}/sbin/libgcc_post_upgrade
%ifarch %{multilib_64_archs}
rm -f $RPM_BUILD_ROOT%{_prefix}/lib/{lib-org*,libffi*,libg2c*,libiberty.a,libobjc*,libstdc++*}
%endif
%ifarch sparc ppc
rm -rf $RPM_BUILD_ROOT%{_prefix}/lib/64
rm -f $RPM_BUILD_ROOT%{_prefix}/lib64/{lib-org*,libffi*,libg2c*,libiberty.a,libobjc*,libstdc++*}
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post -n libstdc++34 -p /sbin/ldconfig

%postun -n libstdc++34 -p /sbin/ldconfig

%post -n libgcj34 -p /sbin/ldconfig

%postun -n libgcj34 -p /sbin/ldconfig

%files
%defattr(-,root,root)
%{_prefix}/bin/gcc34
%{_prefix}/bin/gcov34
%ifarch sparc ppc
%{_prefix}/bin/%{_target_platform}-gcc34
%endif
%ifarch sparc64
%{_prefix}/bin/sparc-%{_vendor}-%{_target_os}-gcc34
%endif
%ifarch ppc64
%{_prefix}/bin/ppc-%{_vendor}-%{_target_os}-gcc34
%endif
%{_prefix}/bin/%{gcc_target_platform}-gcc34
%dir %{_prefix}/lib/gcc
%dir %{_prefix}/lib/gcc/%{gcc_target_platform}
%dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}
%dir %{_prefix}/libexec/gcc
%dir %{_prefix}/libexec/gcc/%{gcc_target_platform}
%dir %{_prefix}/libexec/gcc/%{gcc_target_platform}/%{gcc_version}
%dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/stddef.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/stdarg.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/varargs.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/float.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/limits.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/stdbool.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/iso646.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/syslimits.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/unwind.h
%ifarch %{ix86} x86_64
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/mmintrin.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/xmmintrin.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/emmintrin.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/pmmintrin.h
%endif
%ifarch ia64
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/ia64intrin.h
%endif
%ifarch ppc
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/ppc-asm.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/altivec.h
%endif
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/README
%{_prefix}/libexec/gcc/%{gcc_target_platform}/%{gcc_version}/collect2
%{_prefix}/libexec/gcc/%{gcc_target_platform}/%{gcc_version}/cc1
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/crt*.o
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libgcc.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libgcov.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libgcc_eh.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libgcc_s.so
%ifarch sparc ppc
%dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/64
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/64/crt*.o
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/64/libgcc.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/64/libgcov.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/64/libgcc_eh.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libgcc_s_64.so
%endif
%ifarch %{multilib_64_archs}
%dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/crt*.o
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/libgcc.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/libgcov.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/libgcc_eh.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libgcc_s_32.so
%endif
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/specs
%doc gcc/README* gcc/*ChangeLog*

%files c++
%defattr(-,root,root)
%{_prefix}/bin/%{gcc_target_platform}-*++34
%{_prefix}/bin/g++34
%dir %{_prefix}/lib/gcc
%dir %{_prefix}/lib/gcc/%{gcc_target_platform}
%dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}
%dir %{_prefix}/libexec/gcc
%dir %{_prefix}/libexec/gcc/%{gcc_target_platform}
%dir %{_prefix}/libexec/gcc/%{gcc_target_platform}/%{gcc_version}
%{_prefix}/libexec/gcc/%{gcc_target_platform}/%{gcc_version}/cc1plus
%ifarch sparc ppc
%dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/64
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/64/libstdc++.so
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/64/libstdc++.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/64/libsupc++.a
%endif
%ifarch %{multilib_64_archs}
%dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/libstdc++.so
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/libstdc++.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/libsupc++.a
%endif
%ifarch sparc ppc %{multilib_64_archs}
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libstdc++.so
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libsupc++.a
%endif
%ifarch sparc sparc64 ppc ppc64
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libstdc++.a
%endif
%doc gcc/cp/ChangeLog*

%files -n libstdc++34
%defattr(-,root,root)
%{_prefix}/%{_lib}/libstdc++.so.6*

%files -n libstdc++34-devel
%defattr(-,root,root)
%{_prefix}/include/c++
%dir %{_prefix}/lib/gcc
%dir %{_prefix}/lib/gcc/%{gcc_target_platform}
%dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}
%ifarch sparc ppc
%dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/lib32
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/lib32/libstdc++.a
%endif
%ifarch sparc64 ppc64
%dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/lib64
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/lib64/libstdc++.a
%endif
%ifnarch sparc sparc64 ppc ppc64
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libstdc++.a
%endif
%ifnarch sparc ppc %{multilib_64_archs}
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libstdc++.so
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libsupc++.a
%endif
%doc libstdc++-v3/ChangeLog* libstdc++-v3/README* libstdc++-v3/docs/html/

%if %{build_java}
%files java
%defattr(-,root,root)
%{_prefix}/bin/gcj34
%{_prefix}/bin/gcjh34
%{_prefix}/bin/jcf-dump34
%{_prefix}/bin/jv-scan34
%dir %{_prefix}/lib/gcc
%dir %{_prefix}/lib/gcc/%{gcc_target_platform}
%dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}
%dir %{_prefix}/libexec/gcc
%dir %{_prefix}/libexec/gcc/%{gcc_target_platform}
%dir %{_prefix}/libexec/gcc/%{gcc_target_platform}/%{gcc_version}
%{_prefix}/libexec/gcc/%{gcc_target_platform}/%{gcc_version}/jc1
%{_prefix}/libexec/gcc/%{gcc_target_platform}/%{gcc_version}/jvgenmain
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libgcj.so
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/lib-org-w3c-dom.so
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/lib-org-xml-sax.so
%ifarch sparc sparc64 ppc ppc64
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libgcj.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/lib-org-w3c-dom.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/lib-org-xml-sax.a
%endif
%ifarch sparc ppc
%dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/64
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/64/libgcj.so
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/64/libgcj.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/64/lib-org-w3c-dom.so
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/64/lib-org-w3c-dom.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/64/lib-org-xml-sax.so
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/64/lib-org-xml-sax.a
%endif
%ifarch %{multilib_64_archs}
%dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/libgcj.so
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/libgcj.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/lib-org-w3c-dom.so
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/lib-org-w3c-dom.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/lib-org-xml-sax.so
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/32/lib-org-xml-sax.a
%endif
%doc gcc/java/ChangeLog*

%files -n libgcj34
%defattr(-,root,root)
%{_prefix}/bin/jv-convert34
%{_prefix}/bin/gij34
%{_prefix}/bin/jar34
%{_prefix}/bin/grepjar34
%{_prefix}/bin/rmic34
%{_prefix}/bin/rmiregistry34
%{_prefix}/%{_lib}/libgcj.so.*
%{_prefix}/%{_lib}/lib-org-w3c-dom.so.*
%{_prefix}/%{_lib}/lib-org-xml-sax.so.*
%{_prefix}/share/java
%{_prefix}/lib/security
%{_prefix}/lib/logging.properties

%files -n libgcj34-devel
%defattr(-,root,root)
%{_prefix}/bin/addr2name.awk
%dir %{_prefix}/lib/gcc
%dir %{_prefix}/lib/gcc/%{gcc_target_platform}
%dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}
%dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include
%ifarch sparc ppc
%dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/lib32
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/lib32/libgcj.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/lib32/lib-org-w3c-dom.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/lib32/lib-org-xml-sax.a
%endif
%ifarch sparc64 ppc64
%dir %{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/lib64
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/lib64/libgcj.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/lib64/lib-org-w3c-dom.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/lib64/lib-org-xml-sax.a
%endif
%ifnarch sparc sparc64 ppc ppc64
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libgcj.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/lib-org-w3c-dom.a
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/lib-org-xml-sax.a
%endif
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/libgcj.spec
#%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/gc*.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/j*.h
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/java
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/javax
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/gnu
%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/gcj
#%{_prefix}/lib/gcc/%{gcc_target_platform}/%{gcc_version}/include/org
%{_prefix}/lib/pkgconfig/libgcj.pc
%doc rpm.doc/boehm-gc/* rpm.doc/fastjar/* rpm.doc/libffi/*
%doc rpm.doc/libjava/*
%endif

%changelog
* Tue Apr 20 2004 Jakub Jelinek  <jakub@redhat.com> 3.4.0-1
- GCC 3.4 release
  - PRs bootstrap/14992, other/14918, 14936, ada/14538, ada/14665,
       bootstrap/14462, c/14828, c++/14804, 14219, c++/14808,
       c++/14803, c++/14804, c++/14810, c++/14724, c++/14763,
       c++/14639, bootstrap/14893, libstdc++/14783, libstdc++/13598
- fix some tests on x86-64
- testcase for PR optimization/13488

* Fri Apr  2 2004 Jakub Jelinek  <jakub@redhat.com> 3.4.0-0.9
- different PR optimization/13424 fix

* Wed Mar 31 2004 Jakub Jelinek  <jakub@redhat.com> 3.4.0-0.8
- update from gcc-3_4-branch
  - PRs 11527, bootstrap/12974, bootstrap/14207, c/12373, c/13129, c/14069,
	c++/14481, c++/14545, c++/14586, c++/14587, c++/14616, c/14635,
	debug/13974, libstdc++/14647, libstdc++/14648, middle-end/14470,
	middle-end/14535, optimization/14669, other/14630, other/14630,
	pch/14137, preprocessor/14438, target/13889, target/14206,
	target/14260, target/14291, target/14577, target/14599, target/14676
- link libgcc_s even to C programs and executables if they need
  exception handling
- add support for -m{arch,tune}={prescott,nocona} (Jan Hubicka)
- don't use 3dNOW! prefetches in x86-64 libgcj
  (H.J.Lu, #119022, PR target/14326)
- fix typos in ICE hack, add -frandom-seek=0
- another attempt to fix aggregates with mixed const and non-const
  members and almost-zero initializer (Eric Botcazou, Mark Mitchell,
  PR optimization/13424)
- fix bitfield handling in a.b++ == const to ++a.b == const + 1
  transformations (PR c++/14755)

* Tue Mar 16 2004 Jakub Jelinek  <jakub@redhat.com> 3.4.0-0.7
- update from gcc-3_4-branch
  - PRs 13728, bootstrap/12371, c++/13170, c++/14397, c++/14401,
	c++/14409, c++/14432, c++/14448, c++/14452, c++/14476, c++/14510,
	c++/14550, c/14114, c/14465, c/14517, debug/11983, debug/14079,
	driver/13577, libstdc++/11706, libstdc++/13450, libstdc++/14320,
	libstdc++/3247, middle-end/11767, middle-end/14203,
	middle-end/14289, middle-end/14327, middle-end/14470,
	middle-end/14477, opt/13862, optimization/14235, optimization/14381,
	other/14474, other/14536, target/14047, target/14343, target/14406,
	target/14471, target/14480, target/14496, target/14539, target/14547
  - fix ICE in cp_expr_size (Mark Mitchell, #116213, PR c++/14230)
  - fix s390x ICE in legitimize_pic_address (#117872, PR target/14533)
- fix miscompilation on IA-32 with fix_trunc* between CC setter and
  consumer (Caroline Tice, #118026, PR target/12308)
- emit dwarf2 debug info for __thread vars on ppc/ppc64 (#111628)
- fix gcj ICE on final unitialized local variable used in switch
  (Andrew Haley, #118219, PR java/14581)
- make all subpackages owns all dirs in the gcc-lib tree they are using

* Tue Mar  2 2004 Jakub Jelinek  <jakub@redhat.com> 3.4.0-0.6
- update from gcc-3_4-branch
  - PRs 14240, bootstrap/14207, bootstrap/14356, c++/13944, c++/14138,
	c++/14246, c++/14250, c++/14260, c++/14278, c++/14284, c++/14324,
	c++/14337, c++/14359, c++/14360, c++/14361, c++/14369, c/14188,
	debug/12103, debug/14328, java/14296, libstdc++/10246,
	libstdc++/14248, libstdc++/14252, middle-end/13448,
	optimization/7871, target/14209
- fix PR optimization/12419
- warn if VLAs might free alloca before end of function
  (Alexandre Oliva, PR 14236)
- add --param min-pretend-dynamic-size=NNN option (Alexandre Oliva)
- remove uninstalled binaries and libraries from the install tree,
  so that they don't end up in gcc34-debuginfo (which prevents installing
  both gcc-debuginfo and gcc34-debuginfo together)
- include gcov34 in the package

* Sun Feb 22 2004 Jakub Jelinek  <jakub@redhat.com> 3.4.0-0.5
- fix profiled feedback race

* Sat Feb 21 2004 Jakub Jelinek  <jakub@redhat.com> 3.4.0-0.4
- update from gcc-3_4-branch
  - PRs 12028, 12179, bootstrap/13617, bootstrap/14180, bootstrap/9249,
	c++/11295, c++/11326, c/12818, c++/12850, c++/13086, c++/13113,
	c++/13635, c++/13683, c++/13714, c++/13813, c++/13854, c++/13883,
	c++/13907, c++/13925, c++/13927, c++/13932, c++/13950, c++/13957,
	c++/13968, c++/13969, c++/13970, c++/13971, c++/13975, c++/13978,
	c++/13997, c++/14002, c++/14028, c++/14033, c++/14083, c++/14085,
	c++/14086, c/14088, c/14092, c++/14108, c++/14122, c++/14173,
	c++/14178, c++/14181, c++/14186, c++/14199, c/456, c++/9851,
	c++/9941, debug/12934, fortran/14129, inline-asm/6162, java/13824,
	libstdc++/11352, libstdc++/13731, libstdc++/13858, libstdc++/13976,
	libstdc++/14026, libstdc++/14071, libstdc++/14072, libstdc++/14078,
	libstdc++/14097, libstdc++/14098, libstdc++/5625, middle-end/13696,
	middle-end/13750, optimization/12147, optimization/13424,
	optimization/14119, other/10584, pch/13361, 13485, preprocessor/14103,
	preprocessor/14198, target/11475, target/12476, target/12898,
	target/12978, target/13721, target/13866, target/13914, target/14113,
	target/14201, target/1532
- avoid trailing space in instructions
- ppc64 Java fixes (Alan Modra)
- use push/pop in prologues/epilogues on P4 (Jan Hubicka)
- avoid more than 4 jumps per cacheline on P4 (Jan Hubicka)

* Thu Jan 29 2004 Jakub Jelinek  <jakub@redhat.com> 3.4.0-0.3
- update from gcc-3_4-branch
  - PRs target/7297, target/10904, target/13058, optimization/13567,
	target/13666, bootstrap/13853, target/13674, opt/12941,
	c/13814
- profiledbootstrap on IA-32/AMD64
- include libgcov.a
- fix IA-32/AMD64 string operations (PR optimization/13424)

* Thu Jan 22 2004 Jakub Jelinek  <jakub@redhat.com> 3.4.0-0.2
- fix build of ppc32/sparc32 -m32 only cc1/cc1plus binaries
- temporarily revert IA-64 TI/TFmode patch to put IA-64 into
  bootstrapland

* Wed Jan 21 2004 Jakub Jelinek  <jakub@redhat.com> 3.4.0-0.1
- initial gcc 3.4 package
